// More information about this indicator can be found at:
//http://fxcodebase.com/code/viewtopic.php?f=38&t=69580

//+------------------------------------------------------------------+
//|                               Copyright © 2020, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                           mario.jemic@gmail.com  |
//|                          https://AppliedMachineLearning.systems  |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//|                                 Patreon : https://goo.gl/GdXWeN  |
//+------------------------------------------------------------------+

#property copyright "Copyright © 2020, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"
#property version   "1.0"
#property strict

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrDodgerBlue
#property indicator_color2  clrRed
#property indicator_color3  clrDodgerBlue
#property indicator_color4  clrCrimson
#property indicator_color5  clrLime
#property indicator_color6  clrDimGray
#property indicator_color7  clrDimGray
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame         = PERIOD_CURRENT; // Timeframe to use
extern int    Tenkan                     = 9;              // Tenkan Period
extern int    Kijun                      = 26;             // Kijun Period
extern int    Senkou                     = 52;             // Senkou Period
extern bool   alertsOn                   = false;           // Alerts On?
extern bool   alertsOnKumoCloudCross     = false;          // Alerts on leaving Kumo cloud?
extern bool   alertsOnTenkanKijunCross   = true;           // Alerts on tenkan and kijun cross?
extern bool   alertsOnPriceKijunCross    = false;          // Alerts on price crossing kijun?
extern bool   alertsOnChinkouTenkanCross = false;          // Alerts on Chinkou and Tenkan cross?
extern bool   alertsOnSpanASpanBCross    = true;           // Alerts on SpanA and SpanB cross?
extern bool   alertsOnCurrent            = false;          // Alerts on current open bar?
extern bool   alertsMessage              = true;           // Alerts message?
extern bool   alertsSound                = true;           // Alerts sound?
extern bool   alertsNotify               = false;          // Alerts Send Notification?
extern bool   alertsEmail                = false;          // Alerts send email?
extern int    Shift                      = 26;             // Shift values should = Kijun 
extern bool   Interpolate                = true;           // Interpolate values if multi timeframe is used

extern bool   Draw_Tenkan                = false;           // Draw Tenkan option
extern bool   Draw_Kijun                 = false;           // Draw Kijun option
extern bool   Draw_Kumo                  = true;           // Draw Kumo cloud option
extern bool   Draw_Chikou                = false;           // Draw Chinkou option

extern string             button_note1          = "------------------------------";
extern int                btn_Subwindow = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER;
extern string             btn_text              = "ICHI";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;
extern color              btn_text_ON_color     = clrLime;
extern color              btn_text_OFF_color    = clrRed;
extern string             btn_pressed           = "ICHI OFF";
extern string             btn_unpressed         = "ICHI ON";
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 850;
extern int                button_y              = 0;
extern int                btn_Width             = 75;
extern int                btn_Height            = 20;
extern string             soundBT               = "tick.wav";
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix,buttonId ;

double Tenkan_Buffer[];
double Kijun_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
double Chinkou_Buffer[];
double SpanA2_Buffer[];
double SpanB2_Buffer[];
double trend1[];
double trend2[];
double trend3[];
double trend4[];
double trend5[];
double count[];
string indicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,alertsOn,alertsOnKumoCloudCross,alertsOnTenkanKijunCross,alertsOnPriceKijunCross,alertsOnChinkouTenkanCross,alertsOnSpanASpanBCross,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,0,Interpolate,Draw_Tenkan,Draw_Kijun,Draw_Kumo,Draw_Chikou,button_note1,btn_Subwindow,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_pressed,btn_unpressed,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,soundBT,button_note2,_buff,_ind)

string GenerateIndicatorName(const string target)
  {
   string name = target;
   int try
         = 2;
   while(WindowFind(name) != -1)
     {
      name = target + " #" + IntegerToString(try
                                                ++);
     }
   return name;
  }

int init()
{
   
   IndicatorBuffers(13);
   SetIndexBuffer(0, Tenkan_Buffer); SetIndexStyle(0,Draw_Tenkan  ? DRAW_LINE :  DRAW_NONE);                                 SetIndexLabel(0,"Tenkan Sen");
   SetIndexBuffer(1, Kijun_Buffer);  SetIndexStyle(1,Draw_Kijun  ? DRAW_LINE :  DRAW_NONE);                                 SetIndexLabel(1,"Kijun Sen");
   SetIndexBuffer(2, SpanA_Buffer);  SetIndexStyle(2,Draw_Kumo ? DRAW_HISTOGRAM:  DRAW_NONE);  
   SetIndexBuffer(3, SpanB_Buffer);  SetIndexStyle(3,Draw_Kumo ? DRAW_HISTOGRAM:  DRAW_NONE);  
   SetIndexBuffer(4, Chinkou_Buffer);SetIndexStyle(4,Draw_Chikou  ? DRAW_LINE :  DRAW_NONE);                                 SetIndexLabel(4,"Chinkou Span");
   SetIndexBuffer(5, SpanA2_Buffer); SetIndexStyle(5,DRAW_LINE);                                 SetIndexLabel(5,"Senkou Span A");
   SetIndexBuffer(6, SpanB2_Buffer); SetIndexStyle(6,DRAW_LINE);                                 SetIndexLabel(6,"Senkou Span B");
   SetIndexBuffer(7, trend1); 
   SetIndexBuffer(8, trend2); 
   SetIndexBuffer(9, trend3); 
   SetIndexBuffer(10,trend4); 
   SetIndexBuffer(11,trend5); 
   SetIndexBuffer(12,count);
  
   
     //
     //
     //
     //
     //
     
     indicatorFileName = WindowExpertName();
     TimeFrame         = fmax(TimeFrame,_Period); 
     SetIndexShift(2,Shift  * TimeFrame/_Period); 
     SetIndexShift(3,Shift  * TimeFrame/_Period);
     SetIndexShift(4,-Shift * TimeFrame/_Period);
     SetIndexShift(5,Shift  * TimeFrame/_Period);
     SetIndexShift(6,Shift  * TimeFrame/_Period);    
     
     //
     //
     //
     //
     //
     
     IndicatorShortName(timeFrameToString(TimeFrame)+" Ichimoku"); 
     
     
       IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(WindowExpertName());
   IndicatorDigits(Digits);
   double val;
   if(GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix+btn_text;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);
   
   
return(0);
}

void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
  {
   ObjectDelete(ChartID(),buttonID);
   ObjectCreate(ChartID(),buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
   ObjectSetString(ChartID(),buttonID,OBJPROP_FONT,font);
   ObjectSetString(ChartID(),buttonID,OBJPROP_TEXT,buttonText);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
  }

int deinit()
{
  ObjectsDeleteAll(0,"ICHI");
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
   return(0);
}

bool recalc = true;
void handleButtonClicks()
  {
   if(ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
     {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   handleButtonClicks();
   if(id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
     {
      if(soundBT!="")
         PlaySound(soundBT);
     }
  }

int start()
  {
//template code
   handleButtonClicks();
   recalc = false;

   start2();
   SetIndexBuffer(0, Tenkan_Buffer); SetIndexStyle(0,Draw_Tenkan  ? DRAW_LINE :  DRAW_NONE);                                 SetIndexLabel(0,"Tenkan Sen");
   SetIndexBuffer(1, Kijun_Buffer);  SetIndexStyle(1,Draw_Kijun  ? DRAW_LINE :  DRAW_NONE);                                 SetIndexLabel(1,"Kijun Sen");
   SetIndexBuffer(2, SpanA_Buffer);  SetIndexStyle(2,Draw_Kumo ? DRAW_HISTOGRAM:  DRAW_NONE);  
   SetIndexBuffer(3, SpanB_Buffer);  SetIndexStyle(3,Draw_Kumo ? DRAW_HISTOGRAM:  DRAW_NONE);  
   SetIndexBuffer(4, Chinkou_Buffer);SetIndexStyle(4,Draw_Chikou  ? DRAW_LINE :  DRAW_NONE);                                 SetIndexLabel(4,"Chinkou Span");
   SetIndexBuffer(5, SpanA2_Buffer); SetIndexStyle(5,DRAW_LINE);                                 SetIndexLabel(5,"Senkou Span A");
   SetIndexBuffer(6, SpanB2_Buffer); SetIndexStyle(6,DRAW_LINE);                                 SetIndexLabel(6,"Senkou Span B");

   if(show_data)
     {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_unpressed);
     }
   else
     {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_pressed);
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(5,DRAW_NONE);
      SetIndexStyle(6, DRAW_NONE);
     

      //template code
     }
   return(0);
  }
  
int start2()
{
  

   int i,k,counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   
   int limit = fmin(Bars-counted_bars,Bars-1); count[0]=limit;
  
   if (TimeFrame!=_Period)
   {
      limit = (int)fmax(limit,fmin(Bars-1,_mtfCall(12,0)*TimeFrame/_Period));
      for (i=limit;i>=0 && !_StopFlag; i--)
      {
        
         {
            int y = iBarShift(NULL,TimeFrame,Time[i]);
            Tenkan_Buffer[i]  = _mtfCall(0,y);
            Kijun_Buffer[i]   = _mtfCall(1,y);
            SpanA_Buffer[i]   = _mtfCall(2,y);
            SpanB_Buffer[i]   = _mtfCall(3,y);
            Chinkou_Buffer[i] = _mtfCall(4,y);
            SpanA2_Buffer[i]  = _mtfCall(5,y);
            SpanB2_Buffer[i]  = _mtfCall(6,y);
               
            if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) 
               continue;
            #define _interpolate(buff) buff[i+j] = buff[i]+(buff[i+n]-buff[i])*j/n
            int n,j; datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) 
               continue;	
            for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++) 
            {
               _interpolate(Tenkan_Buffer);
               _interpolate(Kijun_Buffer);
               _interpolate(SpanA_Buffer);
               _interpolate(SpanB_Buffer);
               _interpolate(Chinkou_Buffer);
               _interpolate(SpanA2_Buffer);
               _interpolate(SpanB2_Buffer);
            }                           
         }
         
      }
      return(0);
   }
      
   for(i=limit; i>=0; i--)
   {
     
      {
         double thi    = High[i];
         double tlo    = Low[i];
         double tprice = 0;
         if (i >= Bars - Tenkan) continue;
         for(k = 0; k < Tenkan; k++)
         {
            tprice = High[i+k]; if(thi<tprice) thi = tprice;
            tprice =  Low[i+k]; if(tlo>tprice) tlo = tprice;
         }
         
         if ((thi+tlo) > 0.0) 
            Tenkan_Buffer[i] = (thi + tlo)*0.5; 
         else Tenkan_Buffer[i] = 0;
         
         double khi    = High[i];
         double klo    = Low[i];
         double kprice = 0;
         if  (i >= Bars - Kijun) continue;
         for (k = 0; k < Kijun; k++)
         {
            kprice = High[i+k]; if(khi<kprice) khi = kprice;
            kprice =  Low[i+k]; if(klo>kprice) klo = kprice;
         }
         
         if ((khi+klo) > 0.0) 
               Kijun_Buffer[i] = (khi + klo)*0.5; 
         else Kijun_Buffer[i] = 0;
         
         double shi    = High[i];
         double slo    = Low[i];
         double sprice = 0;
         if  (i >= Bars - Senkou) continue;
         for (k = 0; k < Senkou; k++)
         {
            sprice = High[i+k]; if(shi<sprice) shi  = sprice;
            sprice =  Low[i+k]; if(slo>sprice) slo  = sprice;
         }
         
         SpanA_Buffer[i]   = (Kijun_Buffer[i] + Tenkan_Buffer[i])*0.5;
         SpanA2_Buffer[i]  = (Kijun_Buffer[i] + Tenkan_Buffer[i])*0.5;
         SpanB_Buffer[i]   = (shi + slo)*0.5; 
         SpanB2_Buffer[i]  = (shi + slo)*0.5; 
         Chinkou_Buffer[i] = Close[i]; 
         if (i<Bars-1)
         {
            trend1[i] = trend1[i+1];
            trend2[i] = trend2[i+1];
            trend3[i] = trend3[i+1];
            trend4[i] = trend4[i+1];
            trend5[i] = trend5[i+1];
            if (Close[i] > MathMax(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun])) trend1[i] = 1;
            if (Close[i] < MathMin(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun])) trend1[i] =-1;
            if (Tenkan_Buffer[i]>Kijun_Buffer[i])                                trend2[i] = 1;
            if (Tenkan_Buffer[i]<Kijun_Buffer[i])                                trend2[i] =-1;
            if (Close[i]>Kijun_Buffer[i])                                        trend3[i] = 1;
            if (Close[i]<Kijun_Buffer[i])                                        trend3[i] =-1;
            if (Chinkou_Buffer[i]<Tenkan_Buffer[i])                              trend4[i] = 1;
            if (Chinkou_Buffer[i]>Tenkan_Buffer[i])                              trend4[i] =-1;
            if (SpanA2_Buffer[i]>SpanB2_Buffer[i])                               trend5[i] = 1;
            if (SpanA2_Buffer[i]<SpanB2_Buffer[i])                               trend5[i] =-1;
         }
      }
     
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void manageAlerts()
{
    int whichBar = 1; if (alertsOnCurrent) whichBar = 0;          
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnKumoCloudCross && trend1[whichBar] != trend1[whichBar+1])
      {
         if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar,"Price crossing Kumo up");
         if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar,"Price crossing Kumo down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnTenkanKijunCross && trend2[whichBar] != trend2[whichBar+1])
      {
         if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar,"Tenkan crossing Kijun up");
         if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar,"Tenkan crossing Kijun down");
      }
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnPriceKijunCross && trend3[whichBar] != trend3[whichBar+1])
      {
         if (trend3[whichBar] ==  1) doAlert(time3,mess3,whichBar,"Price crossing Kijun up");
         if (trend3[whichBar] == -1) doAlert(time3,mess3,whichBar,"Price crossing Kijun down");
      }
      static datetime time4 = 0;
      static string   mess4 = "";
      if (alertsOnChinkouTenkanCross && trend4[whichBar] != trend4[whichBar+1])
      {
         if (trend4[whichBar] ==  1) doAlert(time4,mess4,whichBar,"Tenkan crossing Chinkou up");
         if (trend4[whichBar] == -1) doAlert(time4,mess4,whichBar,"Tenkan crossing Chinkou down");
      }
      static datetime time5 = 0;
      static string   mess5 = "";
      if (alertsOnSpanASpanBCross && trend5[whichBar] != trend5[whichBar+1])
      {
         if (trend5[whichBar] ==  1) doAlert(time5,mess5,whichBar,"SpanA crossing SpanB up");
         if (trend5[whichBar] == -1) doAlert(time5,mess5,whichBar,"SpanA crossing SpanB down");
      }
   }

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Ichimoku ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ichimoku "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

